#ifndef foopaa2dpcodechfoo
#define foopaa2dpcodechfoo

/***
  This file is part of PulseAudio.

  Copyright 2018 Pali Rohár <pali.rohar@gmail.com>

  PulseAudio is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2.1 of the
  License, or (at your option) any later version.

  PulseAudio is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with PulseAudio; if not, see <http://www.gnu.org/licenses/>.
***/

typedef struct pa_a2dp_codec {
    const char *codec_name;
    uint8_t codec_id;
    size_t (*fill_capabilities)(uint8_t *, size_t);
    bool (*validate_configuration)(const uint8_t *, size_t);
    size_t (*select_configuration)(const pa_sample_spec *, const uint8_t *, size_t, uint8_t *, size_t);
    void (*init)(void **, pa_sample_spec *, bool, const uint8_t *, size_t);
    void (*finish)(void **);
    void (*setup)(void **);
    void (*fill_blocksize)(void **, size_t, size_t, size_t *, size_t *);
    bool (*fix_latency)(void **);
    size_t (*encode)(void **, uint32_t, const uint8_t *, size_t, uint8_t *, size_t);
    size_t (*decode)(void **, const uint8_t *, size_t, uint8_t *, size_t, size_t *);
} pa_a2dp_codec_t;

extern const pa_a2dp_codec_t pa_a2dp_codec_sbc;
extern const pa_a2dp_codec_t pa_a2dp_codec_aptx;

#endif
